/**
 *
 * ABOUT:
 *	A standalone program debug scanner. Compile in the scanner you want.
 *
 *
 */

#include "bulk_extractor.h"

#include <iostream>
#include <fstream>
#include <string>
#include <stdlib.h>
#include <strings.h>
#include <string.h>
#include <stdint.h>
#include <errno.h>
#include <sstream>
#include <vector>

/**
 * Stand alone tester.
 * 1. allocate an sbuf for the file.
 * 2. Initialize the scanner.
 * 3. Call the scanner.
 * 4. Shut down the scanner.
 */
int debug=0;

scanner_t &the_scanner = scan_json;

int main(int argc,char **argv)
{
    if(argc!=2){
	err(1,"Usage: %s <filename>\n",argv[0]);
    }
    /* Make the sbuf */
    sbuf_t *sbuf = sbuf_t::map_file(argv[1]);
    if(!sbuf){
	err(1,"Cannot map file %s:%s\n",argv[1],strerror(errno));
    }

    set<string>feature_files;
    feature_recorder_set fs(feature_files,".");	// where the features will be put
    scanner_params sp(*sbuf,fs);		// the parameters that we will pass the scanner
    recursion_control_block rcb(0,"",true);

    std::cout << "Initializing scanner...\n";
    sp.phase = 1;			// initialize
    the_scanner(sp,rcb);
    sp.phase = 2;			// scan
    the_scanner(sp,rcb);
    sp.phase = 3;			// shut down
    the_scanner(sp,rcb);
    return(0);
}

